if not oUF then return end

local playerClass = select(2,UnitClass("player"))
local CanDispel = {
	PRIEST = { Magic = true, Disease = true, },
	SHAMAN = { Poison = true, Disease = true, },
	PALADIN = { Magic = true, Poison = true, Disease = true, },
	MAGE = { Curse = true, },
	DRUID = { Curse = true, Poison = true, }
}
local dispellist = CanDispel[playerClass] or {}
local origColors = {}
local origBorderColors = {}
local origPostUpdateAura = {}

local function GetDebuffType(unit, filter)
	local i = 1
	local _, name, debufftype -- name, rank, texture, applications, debufftype, duration, timeLeft = UnitDebuff(unit, buffid)
	while true do
		name, _, _, _, debufftype = UnitDebuff(unit, i)
		if not name or not filter or (filter and dispellist[debufftype]) then
			break
		end
		i = i + 1
	end
	return debufftype
end

local function PostUpdateAura(object, event, unit)
	local debuffType = GetDebuffType(unit, object.DebuffHighlightFilter)
	if debuffType then
		local color = DebuffTypeColor[debuffType] 
		if object.DebuffHighlightBackdrop then
			object:SetBackdropColor(color.r, color.g, color.b, object.DebuffHighlightAlpha or 1)
		else
			object.DebuffHighlight:SetVertexColor(color.r, color.g, color.b, object.DebuffHighlightAlpha or .5)
		end
	else
		if object.DebuffHighlightBackdrop then
			local color = origColors[object]
			object:SetBackdropColor(color.r, color.g, color.b, color.a)
			color = origBorderColors[object]
			object:SetBackdropBorderColor(color.r, color.g, color.b, color.a)
		else
			local color = origColors[object]
			object:SetVertexColor(color.r, color.g, color.b, color.a)
		end
	end
end

local function HookedPostUpdateAura(object, event, unit)
	origPostUpdateAura[object](object, event, unit)
	PostUpdateAura(object, event, unit)
end

local function addHighlight(object)
	-- if we're not highlighting this unit return
	if not object.DebuffHighlightBackdrop and not object.DebuffHighlight then
		return
	end
	-- if we're filtering highlights and we're not of the dispelling type, return
	if object.DebuffHighlightFilter and not CanDispel[playerClass] then
		return
	end
	
	if object.DebuffHighlightBackdrop then
		local r, g, b, a = object:GetBackdropColor()
		origColors[object] = { r = r, g = g, b = b, a = a}
		r, g, b, a = object:GetBackdropBorderColor()
		origBorderColors[object] = { r = r, g = g, b = b, a = a}
	else -- object.DebuffHighlight
		local r, g, b a = object.DebuffHighLight:GetVertexColor()
		origColors[object] = { r = r, g = g, b = b, a = a}
	end
	
	-- there's already a PostUpdateAura active, hook it
	if object.PostUpdateAura then
		origPostUpdateAura[object] = object.PostUpdateAura
		object.PostUpdateAura = HookedPostUpdateAura
	else
		object.PostUpdateAura = PostUpdateAura
	end
end

for object in pairs(oUF.objects) do addHighlight(object) end
oUF:RegisterInitCallback(addHighlight)
